#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>

typedef struct 
{
	char nomE[32];
	char *adresse;
	int capital;
	int duree;
	int prix;
} Devis;

typedef struct maillonDevis
{
	Devis dev;
	struct maillonDevis *suiv;
} MaillonDevis, *ListeDevis;

typedef struct
{
	char travaux[30];
	ListeDevis ldevis;
} Offre;

typedef enum {
	faux, vrai
} Booleen;

typedef struct maillonSucc
{
	char tache[20];
	struct maillonSucc *nxt;
} MaillonSucc, *Liste;

typedef struct
{
	char tache[20]; 
	int duree;
	int nbPred;
	Liste succ;
	int dateDebut;
	bool traite;
} Tache;

typedef struct
{
	char travauxPrec[30];
	char travauxSucc[30];
} Precedence;

//Devis

void displayDevis(Devis d);
Devis readDevis(Offre *tabTravaux[]);

//ListeDevis

ListeDevis 	newListeDevis(void);
ListeDevis 	delete(ListeDevis l);
ListeDevis 	insert(ListeDevis l, Devis d);
ListeDevis  sortListeDevis(ListeDevis l);
Booleen 	emptyListe(ListeDevis l);
int 		lenListeDevis(ListeDevis l);
void 		displayListeDevis(ListeDevis l);

//Offre

Offre newOffre(char *travauxName);
Booleen 	emptyOffre(Offre o);
void 		displayOffre(Offre o);
int 		rechTravaux(char travauxName[], Offre *tabTravaux[]);
void minTravaux(Offre *tabTravaux[]);

//Liste successeurs

Liste newListe(void);
Liste insertSucc(Liste l, char travaux[]);