#include "../includes/charge.h"
#include "../includes/main.h"

char *readAdress(FILE *flot)
{
	char *adresse, *s, aux[5];
	int i=0, tmax=5;
	adresse = (char *)malloc(sizeof(char)*tmax);
	fgets(adresse, 5, flot);

	while (adresse[i]!='\n')
	{
		if (i==tmax)
		{
			tmax+=5;
			s = (char *)realloc(adresse, tmax*sizeof(char));
			if (s==NULL)
			{
				printf("\033[0;31mErreur: \033[0mreallocation pour str adresse\n");
				exit(1);
			}
			adresse=s;
			fgets(aux, 5, flot);
			strcat(adresse, aux);
		}
		i++;
	}
	adresse[strlen(adresse)-1]='\0';
	return adresse;
}

Precedence *loadPrec(int *tmax, int *tlog)
{
	FILE *prec;
	Precedence *tabP, *s;
	prec=fopen("précédence.txt", "r");
	if (prec == NULL)
	{
		printf("\033[0;31mErreur: \033[0mouverture de 'précédence.txt'\n");
	}
	tabP = (Precedence *)malloc((*tmax) * sizeof(Precedence));
	while(!feof(prec))
	{
		if(*tlog==*tmax)
		{
			(*tmax)+=5;
			s = (Precedence *)malloc((*tmax) * sizeof(Precedence));
			if (s==NULL)
			{
				printf("\033[0;31mErreur: \033[0mreallocation pour fichier précédence\n");
				exit(1);
			}
			tabP = s;
		}
		fscanf(prec, "%s%s", tabP[*tlog-1].travauxPrec, tabP[*tlog-1].travauxSucc);
		(*tlog)++;
	}
	fclose(prec);
	return tabP;
}

Tache **chargeTaches(Offre *tabTravaux[])
{
	Precedence *prec;
	int i, tmaxPrec=5, tlogPrec;
	Tache *t, **tabTache;
	tabTache = (Tache **)malloc(8*sizeof(Tache *));
	if (tabTache == NULL)
	{
		printf("\033[0;31mErreur: \033[0mmalloc tableau tache\n");
			exit(1);
	}
	for (i=0; i<tmaxTravaux; i++)
	{
		t=(Tache *)malloc(sizeof(Tache));
		if (t==NULL)
		{
			printf("\033[0;31mErreur: \033[0mmalloc tache\n");
			exit(1);
		}

		strcpy(t->tache, tabTravaux[i]->travaux);
		t->duree = ((tabTravaux[i]->ldevis)->dev).duree;

		prec = loadPrec(&tmaxPrec, &tlogPrec);

		t->nbPred = nombrePred(tabTravaux[i]->travaux, prec, tlogPrec);

		tabTache[i] = t; 
	}
	return tabTache;
}

int nombrePred(char travaux[], Precedence prec[], int tlog)
{
	int nbPred, i;
	for (i=0; i<tlog; i++)
		if (strcmp(travaux, prec[i].travauxSucc)==0)
			nbPred++;
	return nbPred;
}

Liste lstSucc(char travaux[], Precedence prec[], int tlog)
{
	Liste succ = newListe();
	int i;
	for (i=0; i<tlog; i++)
		if(strcmp(travaux, prec[i].travauxPrec))
			succ=insertSucc(succ, prec[i].travauxSucc);
	return succ;
}